// test module ToyVerilog
  
  
module ToyVerilog #()
                            
                           (
                            input  logic   ck,
                            input logic    ckDataIn,
                            input logic    ckDataOut,
                            input  logic   arst,
                            output logic   initialise,
                            output logic   activate_0r,
                            input logic    activate_0a,
                            input logic    i_0r,
                            output logic   i_0a0d,
                            output logic   i_0a1d,
                            input logic    o_0r0d,
                            input logic    o_0r1d,
                            output logic   o_0a,
                            input logic    a,
                            input logic    b,
                            output logic   req,
                            output logic   c,
                            output logic   d,
                            input logic    ack
                   //                         output logic dataRead
                           );



//  logic i_0r_ax;
//  logic i_0r_s;
//  //logic i_0r_edgeDetect;
//  logic [2:0] count;
//  static logic [7:0] data = 8'b10100011;
//  logic d1_ax;
  



  typedef enum logic [1:0] {InitialiseOn         = 0,
                            InitialiseOff        = 1,
                            ActivateOn           = 2,
                            ActivateOff          = 3
                            } StateType;


//  typedef enum logic        {ReleaseData         = 0,
//                            DriveData            = 1
//                            } StateSendData;

  
  StateType state;
//  StateSendData stateSendData;
  
  always_ff @(posedge ck, posedge arst)
    if (arst) begin
      initialise <= 0;
      activate_0r <= 0;
      state <= InitialiseOn;
    end 
    else begin
      case (state)
        
        InitialiseOn: begin
                        initialise <= 1'b1;
                        state <= InitialiseOff;
                      end
      
        InitialiseOff: begin
                        initialise <= 1'b0;
                        state <= ActivateOn;
                       end   
      
        ActivateOn:   begin
                        activate_0r <= 1'b1;
                        if (activate_0a == 1'b1)
                          state <= ActivateOff;
                      end        

        ActivateOff:  begin
                        activate_0r <= 1'b0;
                        state <= ActivateOff;
                      end        

      endcase
      
    end
 
 
  always_ff @(posedge ckDataIn, posedge arst)
     if(arst) begin
       i_0a0d <= 0;
       i_0a1d <= 0;   
     end
     else begin
       i_0a0d <= a;
       i_0a1d <= b;   
     end
 
 assign req = i_0r;
 
 
  always_ff @(posedge ckDataOut, posedge arst)
     if(arst) begin
       o_0a <= 0; 
     end
     else begin
       o_0a <= ack; 
     end
 
assign c = o_0r0d;
assign d = o_0r1d; 
//
//   always_ff @(posedge ck, posedge arst)
//    if (arst) begin
//     i_0r_ax <= 0;
//     i_0r_s  <= 0;
//     //i_0r_edgeDetect <= 0;
//    end
//    else begin
//      i_0r_ax <= i_0r;
//      i_0r_s <= i_0r_ax;
//      //i_0r_edgeDetect <= i_0r_s;
//    end
//
//    //assign ne = (~i_0r_s) & i_0r_edgeDetect;
//    //assign pe = (~i_0r_edgeDetect) & i_0r_s; 
//    
//
//   always_ff @(posedge ck, posedge arst)
//     if(arst) begin
//       i_0a0d <= 0;
//       i_0a1d <= 0;
//       stateSendData <= ReleaseData;
//       count <= 0;
//       
//     end
//     else begin
//       case(stateSendData)
//         ReleaseData: begin
//                        i_0a0d <= 0;
//                        i_0a1d <= 0;
//                        if(i_0r_s == 1) begin
//                          stateSendData <= DriveData;
//                        end
//                      end
//    
//         DriveData:   begin
//                        i_0a0d <= ~data[count];
//                        i_0a1d <= data[count];
//                        if(i_0r_s == 0) begin
//                          stateSendData <= ReleaseData;
//                          count = count + 1;
//                        end
//                      end
//         
//         
//       endcase
//     end
//     
//     
//     
//     RSLATX1 u_RSLAT(.Q(d1), .QN(d0), .R(o_0r0d | arst), .S(o_0r1d) );    
//     assign o_0a = (d1 & o_0r1d) | (d0 & o_0r0d);
//     always_ff @(posedge ck, posedge arst)
//       if (arst) begin
//        d1_ax <= 0;
//        dataRead  <= 0;
//       end
//       else begin
//         d1_ax <= d1;
//         dataRead <= d1_ax;
//       end
//     
//     


endmodule