###################################################################

# Created by write_sdc on Mon Jul 6 12:29:15 2015

###################################################################
set sdc_version 2.0

set_units -time ns -resistance kOhm -capacitance pF -voltage V -current mA
set_max_transition 2 [current_design]
set_load -pin_load 10 [get_ports req]
set_load -pin_load 10 [get_ports c]
set_load -pin_load 10 [get_ports d]
create_clock [get_ports ck]  -period 31.2  -waveform {0 15.6}
group_path -name FEEDTHROUGH  -from [list [get_ports arst] [get_ports ckDataIn] [get_ports ckDataOut] [get_ports a] [get_ports b] [get_ports ack]]  -to [list [get_ports req] [get_ports c] [get_ports d]]
group_path -name REGIN  -from [list [get_ports arst] [get_ports ckDataIn] [get_ports ckDataOut] [get_ports a] [get_ports b] [get_ports ack]]
group_path -name REGOUT  -to [list [get_ports req] [get_ports c] [get_ports d]]
set_input_transition -max 5  [get_ports ck]
set_input_transition -min 5  [get_ports ck]
set_input_transition -max 5  [get_ports arst]
set_input_transition -min 5  [get_ports arst]
set_input_transition -max 5  [get_ports ckDataIn]
set_input_transition -min 5  [get_ports ckDataIn]
set_input_transition -max 5  [get_ports ckDataOut]
set_input_transition -min 5  [get_ports ckDataOut]
set_input_transition -max 5  [get_ports a]
set_input_transition -min 5  [get_ports a]
set_input_transition -max 5  [get_ports b]
set_input_transition -min 5  [get_ports b]
set_input_transition -max 5  [get_ports ack]
set_input_transition -min 5  [get_ports ack]
